Index: inundation/ga/storm_surge/pyvolution/shallow_water.py
===================================================================
--- inundation/ga/storm_surge/pyvolution/shallow_water.py	(revision 521)
+++ inundation/ga/storm_surge/pyvolution/shallow_water.py	(revision 522)
@@ -43,5 +43,5 @@
 
         #Stored output
-        self.store=False
+        self.store = False
 	self.format = 'sww'    
         self.smooth = True
@@ -144,4 +144,7 @@
         """Specialisation of basic evolve method from parent class
         """
+
+        #Call check integrity here rather than from user scripts 
+        self.check_integrity()
         
         #Initialise real time viz if requested
Index: inundation/ga/storm_surge/pyvolution/wind_example.py
===================================================================
--- inundation/ga/storm_surge/pyvolution/wind_example.py	(revision 521)
+++ inundation/ga/storm_surge/pyvolution/wind_example.py	(revision 522)
@@ -1,59 +1,34 @@
 """Example of shallow water wave equation.
 
-Flat bed with wind stress
-
+Flat bed with constant wind stress
 """
 
 ######################
 # Module imports 
-#
 from mesh_factory import rectangular
-from shallow_water import Domain, Reflective_boundary, Dirichlet_boundary,\
-     Transmissive_boundary, Constant_height, Wind_stress
-from Numeric import array
+from shallow_water import Domain, Reflective_boundary, Constant_height, Wind_stress
 
-#Create basic mesh
-N = 80
-len1 = 100
-len2 = 100
-points, vertices, boundary = rectangular(N, N, len1, len2)
+#Create basic mesh (100m x 100m)
+N = 80     
+len = 100
+points, vertices, boundary = rectangular(N, N, len, len)
 
 #Create shallow water domain
 domain = Domain(points, vertices, boundary)
-domain.smooth = True
-domain.visualise = False
-domain.store = True
-domain.default_order=2
+domain.default_order = 2 
 domain.set_name('wind_laminar')
 
 #Set initial conditions
+domain.set_quantity('elevation', 0.0)
+domain.set_quantity('level', 1.0)
+domain.set_quantity('friction', 0.0)
 
-depth = 1
-
-def x_slope(x, y):
-    return 0*x/10
-
-domain.set_quantity('elevation', x_slope)
-domain.set_quantity('level', Constant_height(x_slope, depth))
-
-#Set driving forces
-manning = 0.0
-domain.set_quantity('friction', manning)
-
-
-#Constant windfield implemented using functions
-domain.forcing_terms.append(Wind_stress(9000, 120))
-
+#Constant (quite extreme :-) windfield: 9000 m/s, bearing 120 degrees
+domain.forcing_terms.append( Wind_stress(s=9000, phi=120) )
 
 ######################
 # Boundary conditions
 Br = Reflective_boundary(domain)
-Bd = Dirichlet_boundary([depth, 0, 0])
-
 domain.set_boundary({'left': Br, 'right': Br, 'top': Br, 'bottom': Br})
-#domain.set_boundary({'left': Bd, 'right': Bd, 'top': Bd, 'bottom': Bd})
-#domain.set_boundary({'left': Br, 'right': Bd, 'top': Bd, 'bottom': Bd})
-domain.check_integrity()
-
 
 ######################
Index: inundation/ga/storm_surge/pyvolution/wind_example_rot.py
===================================================================
--- inundation/ga/storm_surge/pyvolution/wind_example_rot.py	(revision 521)
+++ inundation/ga/storm_surge/pyvolution/wind_example_rot.py	(revision 522)
@@ -1,5 +1,5 @@
 """Example of shallow water wave equation.
 
-Flat bed with wind stress
+Flat bed with rotational wind stress
 
 """
@@ -9,13 +9,10 @@
 #
 from mesh_factory import rectangular
-from shallow_water import Domain, Reflective_boundary, Dirichlet_boundary,\
-     Transmissive_boundary, Constant_height, Wind_stress
-from Numeric import array
+from shallow_water import Domain, Reflective_boundary, Wind_stress
 
 #Create basic mesh
 N = 80
-len1 = 100
-len2 = 100
-points, vertices, boundary = rectangular(N, N, len1, len2)
+len = 100
+points, vertices, boundary = rectangular(N, N, len, len)
 
 #Create shallow water domain
@@ -28,24 +25,8 @@
 
 #Set initial conditions
+domain.set_quantity('elevation', 0.0)
+domain.set_quantity('level', 2.0)
+domain.set_quantity('friction', 0.0)
 
-depth = 2
-
-def x_slope(x, y):
-    return 0*x/10
-
-domain.set_quantity('elevation', x_slope)
-domain.set_quantity('level', Constant_height(x_slope, depth))
-
-#Set driving forces
-manning = 0.0
-domain.set_quantity('friction', manning)
-
-
-
-#Constant windfield implemented using functions
-#domain.forcing_terms.append(Wind_stress(5000, 30))
-
-#Constant windfield implemented using (lambda) functions
-#domain.forcing_terms.append(Wind_stress(lambda x,y,t: 5000, lambda x,y,t: 30))
 
 #Variable windfield implemented using functions
@@ -97,4 +78,5 @@
 domain.forcing_terms.append(Wind_stress(speed, phi))
 
+
 #Add lateral wind gusts bearing 25 deg
 def gust(x,y,t): 
@@ -114,11 +96,5 @@
 # Boundary conditions
 Br = Reflective_boundary(domain)
-Bd = Dirichlet_boundary([depth, 0, 0])
-
 domain.set_boundary({'left': Br, 'right': Br, 'top': Br, 'bottom': Br})
-#domain.set_boundary({'left': Bd, 'right': Bd, 'top': Bd, 'bottom': Bd})
-#domain.set_boundary({'left': Br, 'right': Bd, 'top': Bd, 'bottom': Bd})
-domain.check_integrity()
-
 
 ######################
Index: inundation/ga/storm_surge/validation/run_merimbula.py
===================================================================
--- inundation/ga/storm_surge/validation/run_merimbula.py	(revision 521)
+++ inundation/ga/storm_surge/validation/run_merimbula.py	(revision 522)
@@ -24,6 +24,4 @@
 
 domain.default_order = 1
-domain.store = True         #Store for visualisation purposes
-domain.format = 'sww'       #Native netcdf visualisation format
 domain.filename = filename
 