Index: undation/ga/storm_surge/pyvolution/issues.txt
===================================================================
--- /inundation/ga/storm_surge/pyvolution/issues.txt	(revision 536)
+++ 	(revision )
@@ -1,152 +1,0 @@
-CURRENT PYVOLUTION ISSUES
-
-
-OPEN - issues that have not beeen resolved
-
-
-Issue: Adding unknown quantities cause a KeyError.  Known quantities
-are given in the list other_quantities, in shallow_water.  Do we want
-unknown quantities attached to domain in the future?  If so, it
-shouldn't cause a key error.
-Importance: low
-Suggested Action: 
-
-
-Issue: The water level can not be less than the bed elevation, as an
-assert.  
-Importance: Medium
-Suggested Action: How about having the functionality that water levels are set
-to == the bed elevation, if level < bed elevation.  This will make
-setting things up easier.
-
-
-Issue: Transmissive boundary condition can cause unphysical momentums if
-material is not moving out of the domain.
-Importance: Med
-Suggested Action: Add some sort of warning in (subclass of) Transmissive_boundary 
-alerting inflow of material.
-
-Issue:  Run-time error;
-N:\subsandpit\storm_surge\examples>run_tsh.py n cns_ground_pts_triangu
-lation_wave.tsh 10 500
-WARNING: psyco (speedup) could not import, you may want to consider in
-stalling it
-WARNING: psyco (speedup) could not import, you may want to consider in
-stalling it
-Creating domain from cns_ground_pts_triangulation_wave.tsh
-Number of triangles =  4962
-Output being written to C:\grohm_output\cns_ground_pts_triangulation_w
-ave_smooth_ys10.0_ft500.0.sww
-Boundaries
-Available boundary tags are ['external', 'wave']
-Time = 0.0000, steps=0 (0)
-Time = 10.0000, delta t in [0.00000002, 0.47635714], steps=293 (0)
-Time = 20.0000, delta t in [0.00000000, 0.23699587], steps=388 (2)
-Time = 30.0000, delta t in [0.00000009, 0.15411836], steps=429 (0)
-Time = 40.0000, delta t in [0.00000000, 0.18606832], steps=344 (2)
-Time = 50.0000, delta t in [0.00000000, 0.12379432], steps=1106 (7)
-Time = 60.0000, delta t in [0.00000000, 0.13954981], steps=555 (3)
-Time = 70.0000, delta t in [0.00000000, 0.07045416], steps=685 (5)
-Time = 80.0000, delta t in [0.00000000, 0.08044824], steps=670 (4)
-Time = 90.0000, delta t in [0.00000000, 0.08610696], steps=1303 (3)
-Time = 100.0000, delta t in [0.00000000, 0.08309382], steps=2338 (25)
-Time = 110.0000, delta t in [0.00000000, 0.05835182], steps=2725 (33)
-Time = 120.0000, delta t in [0.00000000, 0.06743912], steps=20685 (145
-)
-Time = 130.0000, delta t in [0.00000000, 0.00286429], steps=11866 (72)
-
-Time = 140.0000, delta t in [0.00000000, 0.00515150], steps=6870 (30)
-Traceback (most recent call last):
-  File "N:\subsandpit\storm_surge\examples\run_tsh.py", line 124, in ?
-
-    for t in domain.evolve(yieldstep = yieldstep, finaltime = finaltim
-e):
-  File "I:\storm_surge\pyvolution\shallow_water.py", line 118, in evol
-ve
-    for t in Generic_domain.evolve(self, yieldstep, finaltime):
-  File "I:\storm_surge\pyvolution\domain.py", line 295, in evolve
-    self.update_timestep(yieldstep, finaltime)
-  File "I:\storm_surge\pyvolution\domain.py", line 387, in update_time
-step
-    raise msg
-Minimal timestep 0.0000000000000124 reached using 1 order scheme
-___________________________
-revision 187
-____________________________________________________________
-Another example:
-N:\subsandpit\storm_surge\examples>run_tsh.py n holl_bch_wave_mesh_ele
-vation.tsh 1 10
-WARNING: psyco (speedup) could not import, you may want to consider in
-stalling it
-WARNING: psyco (speedup) could not import, you may want to consider in
-stalling it
-Creating domain from holl_bch_wave_mesh_elevation.tsh
-Number of triangles =  4802
-Output being written to C:\grohm_output\holl_bch_wave_mesh_elevation_s
-mooth_ys1.0_ft10.0.sww
-Boundaries
-Available boundary tags are ['external', 'wave']
-Time = 0.0000, steps=0 (0)
-Time = 1.0000, delta t in [0.39257526, 0.48254865], steps=3 (0)
-Time = 2.0000, delta t in [0.00000292, 0.38907979], steps=137 (0)
-Time = 3.0000, delta t in [0.00000002, 0.01413876], steps=287 (0)
-Time = 4.0000, delta t in [0.00000005, 0.01021096], steps=500 (5)
-Time = 5.0000, delta t in [0.00000051, 0.03515667], steps=228 (0)
-Time = 6.0000, delta t in [0.00000002, 0.01138309], steps=509 (2)
-Time = 7.0000, delta t in [0.00000160, 0.03278703], steps=157 (0)
-Time = 8.0000, delta t in [0.00000004, 0.04026312], steps=828 (1)
-Traceback (most recent call last):
-  File "N:\subsandpit\storm_surge\examples\run_tsh.py", line 124, in ?
-
-    for t in domain.evolve(yieldstep = yieldstep, finaltime = finaltim
-e):
-  File "I:\storm_surge\pyvolution\shallow_water.py", line 118, in evol
-ve
-    for t in Generic_domain.evolve(self, yieldstep, finaltime):
-  File "I:\storm_surge\pyvolution\domain.py", line 295, in evolve
-    self.update_timestep(yieldstep, finaltime)
-  File "I:\storm_surge\pyvolution\domain.py", line 387, in update_time
-step
-    raise msg
-Minimal timestep 0.0000000157247884 reached using 1 order scheme
-________________________________________
-revision 295
-_________________________________________________________
-
-
-****************
-CLOSED - issues that have  beeen resolved
-************
-
-
-New example 26/10 16:20
-
-V:\7\cit\workspaces\ws_nielsen\projects\storm_surge\examples>python run_
- cns_ground_pts_triangulation_wave.tsh 10 500
-Creating domain from cns_ground_pts_triangulation_wave.tsh
-Number of triangles =  4962
-Output being written to C:\grohm_output\cns_ground_pts_triangulation_wav
-_ys10.0_ft500.0.sww
-Boundaries
-Available boundary tags are ['external', 'wave']
-Time = 0.0000, steps=0 (0)
-Time = 10.0000, delta t in [0.00018562, 0.47635714], steps=296 (0)
-Time = 20.0000, delta t in [0.00058530, 0.37116719], steps=267 (0)
-Time = 30.0000, delta t in [0.00014949, 0.22819244], steps=282 (0)
-Time = 40.0000, delta t in [0.00000000, 0.15756478], steps=478 (0)
-Time = 50.0000, delta t in [0.00000000, 0.32346737], steps=648 (1)
-Time = 60.0000, delta t in [0.00000000, 0.24878640], steps=664 (0)
-Time = 70.0000, delta t in [0.00000000, 0.08966319], steps=819 (0)
-Time = 80.0000, delta t in [0.00000000, 0.05706256], steps=1518 (1)
-Time = 90.0000, delta t in [0.00000000, 0.06957202], steps=2129 (3)
-Time = 100.0000, delta t in [0.00000000, 0.08955953], steps=3644 (18)
-Time = 110.0000, delta t in [0.00000000, 0.05102101], steps=2120 (0)
-Time = 120.0000, delta t in [0.00000000, 0.07261881], steps=2423 (0)
-Time = 130.0000, delta t in [0.00000000, 0.07346308], steps=2366 (1)
-Time = 140.0000, delta t in [0.00000000, 0.17995247], steps=2825 (5)
-Time = 150.0000, delta t in [0.00000000, 0.08268458], steps=1477 (0)
-Time = 160.0000, delta t in [0.00000000, 0.07423284], steps=3631 (0)
-Time = 170.0000, delta t in [0.00000000, 0.07305694], steps=4369 (31)
-Time = 180.0000, delta t in [0.00000000, 0.06342947], steps=3235 (0)
-Time = 190.0000, delta t in [0.00000000, 0.10134596], steps=2235 (0)
-Time = 200.0000, delta t in [0.00000000, 0.06387375], steps=4239 (10)
Index: /inundation/ga/storm_surge/wiki/issues_june2004.txt
===================================================================
--- /inundation/ga/storm_surge/wiki/issues_june2004.txt	(revision 536)
+++ /inundation/ga/storm_surge/wiki/issues_june2004.txt	(revision 537)
@@ -24,4 +24,26 @@
 Issue: Checkpointing - needs to respect changes in script.
 
+
+Issue: Adding unknown quantities cause a KeyError.  Known quantities
+are given in the list other_quantities, in shallow_water.  Do we want
+unknown quantities attached to domain in the future?  If so, it
+shouldn't cause a key error.
+Importance: low
+Suggested Action: 
+
+
+Issue: The water level can not be less than the bed elevation, as an
+assert.  
+Importance: Medium
+Suggested Action: How about having the functionality that water levels are set
+to == the bed elevation, if level < bed elevation.  This will make
+setting things up easier.
+
+
+Issue: Transmissive boundary condition can cause unphysical momentums if
+material is not moving out of the domain.
+Importance: Med
+Suggested Action: Add some sort of warning in (subclass of) Transmissive_boundary 
+alerting inflow of material.
 
 