Index: /inundation/ga/storm_surge/pyvolution/wiki/issues.txt
===================================================================
--- /inundation/ga/storm_surge/pyvolution/wiki/issues.txt	(revision 544)
+++ /inundation/ga/storm_surge/pyvolution/wiki/issues.txt	(revision 544)
@@ -0,0 +1,105 @@
+
+OPEN ISSUES:
+------------
+
+Issue: Exceptions thrown by Python functions called from C don't get caughts
+Background: Have a look at gravity in shallow_water. It calls a C function, gradient, which may throw an exception if arguments are scalars.
+However, it doesn't get caught becuase gravity itself is called from within C
+Importance: Mid
+Suggested Action: Have a look at the calling convention from C (David Beasley)
+Status: Unresolved
+
+
+Issue: Parameters specified in config.py must be tranferred to C code 
+and it should be possible to override them when setting up a domain.
+Background: N/A
+Importance: Mid
+Suggested Action: 
+	  1: Let domain read the config file to provide default values.
+	  2: Write getters and setters to override them.
+	  3: Pass pertinent values from domain into the c-extensions.
+Status: Unresolved, D+O agreed to do it this way 18/5
+
+
+Issue: Checkpointing - needs to respect changes in script.
+
+
+Issue: Adding unknown quantities cause a KeyError.  Known quantities
+are given in the list other_quantities, in shallow_water.  Do we want
+unknown quantities attached to domain in the future?  If so, it
+shouldn't cause a key error.
+Importance: low
+Suggested Action: 
+
+
+Issue: The water level can not be less than the bed elevation, as an
+assert.  
+Importance: Medium
+Suggested Action: How about having the functionality that water levels are set
+to == the bed elevation, if level < bed elevation.  This will make
+setting things up easier.
+
+
+Issue: Transmissive boundary condition can cause unphysical momentums if
+material is not moving out of the domain.
+Importance: Med
+Suggested Action: Add some sort of warning in (subclass of) Transmissive_boundary 
+alerting inflow of material.
+
+
+	
+CLOSED ISSUES:
+--------------	
+
+Issue: Second order limiters may cause numerical problems 
+manifesting themselves as QNAN (Quiet NANs_ or INF)
+Background: The second order gradient limiter is not robust enough - 
+especially with shallow water depths. Heighs and momentum are 
+limited independently and high speeds may result.
+Importance: Mid
+Suggested Action: 
+	  1: Try to incorporate a weighted averaging process between 
+	  shallow depths and large depths as in the first order scheme.
+	  2: Look at limiting height and momentum together, by keeping 
+	  an eye on the speeds 
+	  (e.g make speed constant across a volume and recompute momentum)
+	  3: Catch errors resulting from these instabilities as early 
+	  as possibly and produce and throw an appropriate exception
+	  4: Make small example that reveals this bug.
+Status: 1 succesfully implemented by Ole and Stephen 12/5/4.
+	2 Didn't work but using the weighted average for momentums seemed 
+	to work well.
+	3 and 4 not done.
+	June 2004: With the new limiter (item 1 and 2) 3 and 4 are probably 
+	not necessary now.
+
+
+
+Issue: Tags for specifying boundary conditions should be arbitrary
+Background: Domain has the functionality for using arbitrary keys
+when associating boundary objects to boundary values.
+Triangle, which pmesh is based on, uses integers only.
+It would be nice to have mnemonic names for boundaries throughout.
+Importance: Mid
+Status: Duncan resolved this in early June.
+
+
+
+
+Issue: Checkpointing - needs to always back one timestep up in 
+       case output wasn't written
+Background:
+       Data at latest checkpoint may be incomplete or even corrupted 
+       depending on when and how program was stopped.
+Importance: Mid
+Suggested Action: Always try second latest checkpoint first.
+Status: Done (Ole 14/5/4)
+              
+
+		
+Issue: interpolated_conserved_quantities in shallow_water.py
+Background: Was computed by flux functions and used by bed_slope.
+It turns out to be unneccessary as conserved quantities at centroid works just as well.
+Importance: Mid
+Suggested Action: Get rid of it everywhere
+Status: Was done when whole things was refactored in April 2004 by OMN
Index: /inundation/ga/storm_surge/pyvolution/wiki/long_term_design.txt
===================================================================
--- /inundation/ga/storm_surge/pyvolution/wiki/long_term_design.txt	(revision 544)
+++ /inundation/ga/storm_surge/pyvolution/wiki/long_term_design.txt	(revision 544)
@@ -0,0 +1,10 @@
+
+	
+Migrate code from domain.py so as much as possible is
+done in terms of the consecutive arrays. 
+We can then destroy the Python objects after everything has been setup,
+in order to conserved memory.
+	
+	
+Tagged regions, edges etc should be done in terms of set-theory,
+so that each tag maps e.g. to a list of indices.	
Index: /inundation/ga/storm_surge/pyvolution/wiki/pyvolution_SRS.txt
===================================================================
--- /inundation/ga/storm_surge/pyvolution/wiki/pyvolution_SRS.txt	(revision 544)
+++ /inundation/ga/storm_surge/pyvolution/wiki/pyvolution_SRS.txt	(revision 544)
@@ -0,0 +1,53 @@
+Pyvolution Software Requirements Specification
+By 
+
+$Revision: 1.2 $
+$Date: 2004/06/30 00:12:33 $
+
+INTRODUCTION
+
+
+OVERALL DESCRIPTION 
+
+
+
+DEFINITIONS
+
+REQUIREMENT SECTION
+
+Introduction
+
+Each requirement has a priority (e.g. P1).  The priority number is
+given at the end of each requirement.
+
+Requirements
+- The information from a .tsh file shall be converted to a data
+structure that pyvolution understands.
+ - The vertex attribute information will be converted to field values
+ and they shall be accessable using the attribute tag.
+
+- Volumes will have a region tag. This shall be implemented using the
+  principals of set theory.
+
+- For a given region and a given field value/conserved quantity apply
+  a supplied function with parameters (x,y and the old value
+  of the field value/conserved quantity).  
+  - Also need a flag specifying if the vertex or centroid values are
+  being set.(Rational - will can be used to avoid discontinuites/ or
+  create them, depending on what is required.)
+  Example calls: domain.set_field_values('bed_elevation', 
+		   			 f, location='vertices')
+					 
+  Example calls: domain.set_conserved_quantities('stage', f, 
+					         location='centroid')
+					 				 
+					
+					
+  where f has the form
+  def f(x, y, old_value):
+      ...
+      return z										 
+ 
+ 
+CVS INFORMATION FOR THIS FILE
+$Source: /var/lib/cvs/grohm/wiki/pyvolution_SRS.txt,v $
Index: undation/ga/storm_surge/wiki/issues.txt
===================================================================
--- /inundation/ga/storm_surge/wiki/issues.txt	(revision 543)
+++ 	(revision )
@@ -1,105 +1,0 @@
-
-OPEN ISSUES:
-------------
-
-Issue: Exceptions thrown by Python functions called from C don't get caughts
-Background: Have a look at gravity in shallow_water. It calls a C function, gradient, which may throw an exception if arguments are scalars.
-However, it doesn't get caught becuase gravity itself is called from within C
-Importance: Mid
-Suggested Action: Have a look at the calling convention from C (David Beasley)
-Status: Unresolved
-
-
-Issue: Parameters specified in config.py must be tranferred to C code 
-and it should be possible to override them when setting up a domain.
-Background: N/A
-Importance: Mid
-Suggested Action: 
-	  1: Let domain read the config file to provide default values.
-	  2: Write getters and setters to override them.
-	  3: Pass pertinent values from domain into the c-extensions.
-Status: Unresolved, D+O agreed to do it this way 18/5
-
-
-Issue: Checkpointing - needs to respect changes in script.
-
-
-Issue: Adding unknown quantities cause a KeyError.  Known quantities
-are given in the list other_quantities, in shallow_water.  Do we want
-unknown quantities attached to domain in the future?  If so, it
-shouldn't cause a key error.
-Importance: low
-Suggested Action: 
-
-
-Issue: The water level can not be less than the bed elevation, as an
-assert.  
-Importance: Medium
-Suggested Action: How about having the functionality that water levels are set
-to == the bed elevation, if level < bed elevation.  This will make
-setting things up easier.
-
-
-Issue: Transmissive boundary condition can cause unphysical momentums if
-material is not moving out of the domain.
-Importance: Med
-Suggested Action: Add some sort of warning in (subclass of) Transmissive_boundary 
-alerting inflow of material.
-
-
-	
-CLOSED ISSUES:
---------------	
-
-Issue: Second order limiters may cause numerical problems 
-manifesting themselves as QNAN (Quiet NANs_ or INF)
-Background: The second order gradient limiter is not robust enough - 
-especially with shallow water depths. Heighs and momentum are 
-limited independently and high speeds may result.
-Importance: Mid
-Suggested Action: 
-	  1: Try to incorporate a weighted averaging process between 
-	  shallow depths and large depths as in the first order scheme.
-	  2: Look at limiting height and momentum together, by keeping 
-	  an eye on the speeds 
-	  (e.g make speed constant across a volume and recompute momentum)
-	  3: Catch errors resulting from these instabilities as early 
-	  as possibly and produce and throw an appropriate exception
-	  4: Make small example that reveals this bug.
-Status: 1 succesfully implemented by Ole and Stephen 12/5/4.
-	2 Didn't work but using the weighted average for momentums seemed 
-	to work well.
-	3 and 4 not done.
-	June 2004: With the new limiter (item 1 and 2) 3 and 4 are probably 
-	not necessary now.
-
-
-
-Issue: Tags for specifying boundary conditions should be arbitrary
-Background: Domain has the functionality for using arbitrary keys
-when associating boundary objects to boundary values.
-Triangle, which pmesh is based on, uses integers only.
-It would be nice to have mnemonic names for boundaries throughout.
-Importance: Mid
-Status: Duncan resolved this in early June.
-
-
-
-
-Issue: Checkpointing - needs to always back one timestep up in 
-       case output wasn't written
-Background:
-       Data at latest checkpoint may be incomplete or even corrupted 
-       depending on when and how program was stopped.
-Importance: Mid
-Suggested Action: Always try second latest checkpoint first.
-Status: Done (Ole 14/5/4)
-              
-
-		
-Issue: interpolated_conserved_quantities in shallow_water.py
-Background: Was computed by flux functions and used by bed_slope.
-It turns out to be unneccessary as conserved quantities at centroid works just as well.
-Importance: Mid
-Suggested Action: Get rid of it everywhere
-Status: Was done when whole things was refactored in April 2004 by OMN
Index: undation/ga/storm_surge/wiki/long_term_design.txt
===================================================================
--- /inundation/ga/storm_surge/wiki/long_term_design.txt	(revision 543)
+++ 	(revision )
@@ -1,10 +1,0 @@
-
-	
-Migrate code from domain.py so as much as possible is
-done in terms of the consecutive arrays. 
-We can then destroy the Python objects after everything has been setup,
-in order to conserved memory.
-	
-	
-Tagged regions, edges etc should be done in terms of set-theory,
-so that each tag maps e.g. to a list of indices.	
Index: undation/ga/storm_surge/wiki/pyvolution_SRS.txt
===================================================================
--- /inundation/ga/storm_surge/wiki/pyvolution_SRS.txt	(revision 543)
+++ 	(revision )
@@ -1,53 +1,0 @@
-Pyvolution Software Requirements Specification
-By 
-
-$Revision: 1.2 $
-$Date: 2004/06/30 00:12:33 $
-
-INTRODUCTION
-
-
-OVERALL DESCRIPTION 
-
-
-
-DEFINITIONS
-
-REQUIREMENT SECTION
-
-Introduction
-
-Each requirement has a priority (e.g. P1).  The priority number is
-given at the end of each requirement.
-
-Requirements
-- The information from a .tsh file shall be converted to a data
-structure that pyvolution understands.
- - The vertex attribute information will be converted to field values
- and they shall be accessable using the attribute tag.
-
-- Volumes will have a region tag. This shall be implemented using the
-  principals of set theory.
-
-- For a given region and a given field value/conserved quantity apply
-  a supplied function with parameters (x,y and the old value
-  of the field value/conserved quantity).  
-  - Also need a flag specifying if the vertex or centroid values are
-  being set.(Rational - will can be used to avoid discontinuites/ or
-  create them, depending on what is required.)
-  Example calls: domain.set_field_values('bed_elevation', 
-		   			 f, location='vertices')
-					 
-  Example calls: domain.set_conserved_quantities('stage', f, 
-					         location='centroid')
-					 				 
-					
-					
-  where f has the form
-  def f(x, y, old_value):
-      ...
-      return z										 
- 
- 
-CVS INFORMATION FOR THIS FILE
-$Source: /var/lib/cvs/grohm/wiki/pyvolution_SRS.txt,v $